function Dialog_Text, TITLE = title, LABEL = label, GROUP_LEADER = group_leader, FONT = font
;
;	dialog popup that gets text from a user (filenames, or directories, usually)
;
;	return = text string, if all went well
;	       = -1 if failed
;
;	inputs:  TITLE = string to put on window base
;            LABEL = string to put over text input window, describing what is sought
;			 GROUP_LEADER = widget id of calling routine, defaults to zero if not present
;
;	DPC		20071023	initial code
;
do_title = 1
do_label = 1
if(N_ELEMENTS(TITLE) eq 0) then begin
	do_title = 0
	title=''
endif
if(N_ELEMENTS(LABEL) eq 0) then begin
	do_label = 0
	label = ''
endif
if(N_ELEMENTS(GROUP_LEADER) eq 0) then begin
   group_leader = Widget_Base(Map=0)				; ala Fanning, create an unshown base
   Widget_Control, group_leader, /Realize
   destroy_groupleader = 1
ENDIF ELSE destroy_groupleader = 0
if(N_ELEMENTS(FONT) eq 0) then font=''
;
;	launch the GUI
;
;     create a heap variable structure and pointer to pass to the
;     pop up widget
;
w_ptr = PTR_NEW()
wStruct = {ptr: w_ptr, label_wid: -1L, text_wid: -1L, title_wid: -1L, widget_wid: -1L, text_string: '', $
			do_title: do_title, do_label: do_label, title: title, label: label, font: font}
;
DTW_ptr = PTR_NEW(wStruct)		; make the heap variable and pointer
;
DTW_struct_ptr = {ptr: DTW_ptr}	; make a new structure that holds the pointer
;
;   call the pop up, passing the pointer
;
Dialog_Text_Window, GROUP_LEADER=group_leader, _EXTRA = DTW_struct_ptr
;
DTW_ptr = DTW_struct_ptr.ptr
;
; get text, if no cancel
;
cancel_wid = (*DTW_ptr).label_wid
text_string = (*DTW_ptr).text_string
if(text_string eq '') then cancel_wid = -1
;
PTR_FREE, DTW_ptr
PTR_FREE, w_ptr
if(destroy_groupleader) then WIDGET_CONTROL, group_leader, /DESTROY
;
if(N_ELEMENTS(text_string) ne 0 and cancel_wid ne -1) then RETURN, text_string else RETURN, -1L
;
end


