;
;	Part 1 Event Handler routines - Run organization
;
;--------------------------------------------------------------------------------------------------------------
pro P1_Create_New_Run_Name, Event
	;
	MSP_BDP_print_text, Event, "Creation of New Run Name requested"
	;
	;print, "Got to P1_Create_new_run_name"
	;
    WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
    s_ptr = PTR_struct.PTR_summary
    ;
    return = Dialog_Text(Title="Create New Run Name", Label="Enter Run Designator (YYYYMM)", $
                           Font='Helvetica*18', Group_Leader = Event.top)
    ;
    if(SIZE(return,/TYPE) ne 7) then begin
	    if( return eq -1) then begin
	    	MSP_BDP_print_text, Event, "ERROR - No text entered. Try Again."
	    	goto, P1_CNRN_end
	    endif
	endif
    ;
    (*s_ptr).run_name = return
    ;
    ; go back to old font
    WIDGET_CONTROL, DEFAULT_FONT = (*s_ptr).default_font
    ;
    ;	select root directories
    ;
    (*s_ptr).root_raw = Dialog_Pickfile(Title="Select Raw Data Root Directory",/directory)
    (*s_ptr).root_reduced = Dialog_Pickfile(Title="Select Reduced Data Root Directory",/directory)
    ;
    (*s_ptr).last_date = systime()
    (*s_ptr).who = Dialog_Text(Title="Data Reduction Operator", Label="Enter Your Name", $
    						Font='Helvetica*24', Group_Leader = Event.top)
    						;
    WIDGET_CONTROL, DEFAULT_FONT = (*s_ptr).default_font
    ;
    ;	reset TLB title
    ;
    TLB_Title = (*s_ptr).version_string + $
    			' '+(*s_ptr).who+' '+SYSTIME()+' for Run '+(*s_ptr).run_name
    tlb_wid = WIDGET_INFO( Event.top, FIND_BY_UNAME='MSP_BDP_Base')
    ;
    WIDGET_CONTROL, tlb_wid, TLB_SET_TITLE=TLB_Title
    ;
    ;	clear number of nights for now
    ;
    (*s_ptr).num_nights = 0L
    ;
    ;	save run summary information to reduced data directory
    ;
    P1_Write_Summary_File, Event
    ;
    ;	write the backup summary file
    ;
    P1_Write_Summary_File, Event, /BACKUP
    ;
    MSP_BDP_print_text, Event, "New Run Summary File Created"
    ;
    P1_CNRN_end:
end
;
;-------------------------------------------------------------------------
pro P1_Write_Summary_File, Event, BACKUP=backup
	;
	if(N_ELEMENTS(BACKUP) ne 0) then backup=1 else backup=0
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	;
    if(backup eq 0) then begin
    	summary_file = STRTRIM( (*s_ptr).run_name,2) + "_summary.dat"
    endif else begin
    	summary_file = STRTRIM( (*s_ptr).run_name,2) + "_summary_backup.dat"
    endelse
    ;
    pathname = fix_path(FILEPATH(summary_file, ROOT_DIR = (*s_ptr).root_reduced, $
    			SUBDIRECTORY='0_Analysis_Summary'))
    summary_log = FILE_DIRNAME( pathname, /MARK_DIRECTORY)
    test = FILE_INFO( summary_log )
    if( NOT(test.exists) or NOT(test.directory) ) then FILE_MKDIR, summary_log
    ;
    ;	mark time/date of writing
    ;
    (*s_ptr).last_date = systime()
    ;
    ;	if the log file is not yet opened, do so
    ;
    if( (*s_ptr).log_file eq '') then begin
    	mon = ''
    	reads, (*s_ptr).last_date, format='(4x,A3,1x,i2,1x,i2,1x,i2,1x,i2,1x,i4)',mon,day,hh,mm,ss,year
    	amon = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
    	imon = WHERE(mon eq amon[*])
    	ymdhm = ulong64(year)*100000000L + ulong64(imon[0]+1)*1000000L + ulong64(day)*10000L + ulong64(hh)*100L + ulong64(mm)
    	(*s_ptr).log_file = fix_path(FILEPATH("log_"+STRING(format='(I12.12)',ymdhm)+".dat", $
    						ROOT_DIR = (*s_ptr).root_reduced, SUBDIRECTORY='1_Analysis_Logs'))
    	;
    	;	check that the directory exists. if not, create it.
    	;
    	log_dir = FILE_DIRNAME( (*s_ptr).log_file, /MARK_DIRECTORY)
    	test = FILE_INFO( log_dir )
    	if( NOT(test.exists) or NOT(test.directory) ) then FILE_MKDIR, log_dir
    	openw, lu_log, (*s_ptr).log_file, /GET_LUN
    	(*s_ptr).lu_log = lu_log
    endif
    ;
    ;	open and write key data
    ;
    openw, lu_summary, pathname, /GET_LUN
    	printf, lu_summary, format="('RUN_NAME::',32x, A6,2x,'::Run Name Designator')",(*s_ptr).run_name
    	printf, lu_summary, format="('LASTDATE::',14x,A24,2x,'::Date of Last Change')",(*s_ptr).last_date
    	printf, lu_summary, format="('REDUCER ::',    A38,2x,'::Person Reducing Run')",(*s_ptr).who
    	printf, lu_summary, format="('ROOT_RAW::',2x,A)", (*s_ptr).root_raw
    	printf, lu_summary, format="('ROOT_RED::',2x,A)", (*s_ptr).root_reduced
    	printf, lu_summary, format="('NUM_NHTS::',32x, I6,2x,'::Number of Nights in Run')",(*s_ptr).num_nights
    	if((*s_ptr).num_nights gt 0) then begin
    		for inight = 0, (*s_ptr).num_nights-1 do begin
    			;
    			printf, lu_summary, format="('NIGHT::',I2.2,'::Date::',I8.8,'::Nimages::',I5.5,'::Step::',i2.2,'::Comment:: ',a,'::Who::',a)",$
    			                     inight+1,(*s_ptr).night_date[inight], (*s_ptr).night_images[inight],$
    			                     (*s_ptr).night_step[inight],(*s_ptr).night_comment[inight],$
    			                     (*s_ptr).night_who[inight]
    	    endfor
    	endif
    FREE_LUN, lu_summary
	;
	if(backup eq 0) then begin
	    ;
	    ;	make P1 buttons sensitive
	    ;
	    sense = 1
	    for i_P1 = 2, 6 do begin
			P1_button_sensitize, Event, i_P1, sense
		endfor
	    ;
		MSP_BDP_print_text, Event, "Wrote Summary File "+pathname+" to Disk"
		;
	endif
end
;
;-----------------------------------------------------------------
pro P1_Open_Existing_Run, Event
	;
	MSP_BDP_print_text, Event, "Open Existing Analysis Run requested"
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	;
	s_ptr = PTR_struct.PTR_summary
	;
    ;	select root reduced data directory
    ;
    summary_dir = Dialog_Pickfile(Title="Reductions Directory",/directory)
    if(summary_dir eq '') then begin
    	MSP_BDP_print_text, Event, "No directory specified. Try again."
    	goto, P1_OER_end
    endif
    ;
    ;	in that directory, look for the analysis summary sub directory
    ;
    root_dir = summary_dir
	summary_dir = fix_path(summary_dir + PATH_SEP() + '0_Analysis_Summary')
	test_dir = FILE_INFO(summary_dir)
	if(test_dir.exists ne 1 or test_dir.directory ne 1) then begin
		MSP_BDP_print_text, Event, 'ERROR - Anayisis directory absent - Try again.'
		goto, P1_OER_end
	endif
	;
	(*s_ptr).root_reduced = fix_path(root_dir)
	;
	;print, "reduced root = ",(*s_ptr).root_reduced
    ;
    (*s_ptr).last_date = systime()
    return_value = Dialog_Text(Title="Data Reduction Operator", Label="Enter Your Name", $
    						Font='Helvetica*24', Group_Leader = Event.top)
    ;
    if(SIZE(return_value,/TYPE) ne 7) then begin		; check for -1 error code
	    if(return_value eq -1) then begin
	    	MSP_BDP_print_text, Event, "ERROR - No Text Entered. Try Again."
	    	goto, P1_OER_end
	    endif
	endif
    ;
    WIDGET_CONTROL, DEFAULT_FONT = (*s_ptr).default_font
    ;
    ;	find, open, and read from the summary file
    ;
    files = FILE_SEARCH(summary_dir,'*_summary.dat')
    nfiles = N_ELEMENTS(files)
    if(nfiles eq 1) then begin
    	len = STRLEN(files[0])
    	if(len eq 0) then begin
    		MSP_BDP_print_text, Event, "ERROR - run summary file not found. Try again."
    		goto, P1_OER_end
    	endif
    	;
    	;	the one file found is the right one
    	;
    	summary_path = files[0]
    endif else begin
    	;
    	;	multiple files, write error
    	;
    	MSP_BDP_print_text, Event, "ERROR - found "+STRING(nfiles)+" summary files. Fix this."
    	goto, P1_OER_end
    endelse
    ;
    openr, lu_summary, summary_path, /GET_LUN
    ;
    line = ''
    st_var = ''
    lng_var = 0L
    i_var = 0
    jnight = 0
    WHILE (~EOF(lu_summary)) do begin
    	readf, lu_summary, line
    	parts = STRSPLIT(line,"::",/REGEX,/EXTRACT, Count=count)		; break into parts
    	if(count ne 0) then begin
    		;
    		;	found "::" separator, examine pieces
    		;
    		parts[0] = STRTRIM(parts[0],2)
    		if(parts[0] eq 'RUN_NAME') then begin
    			reads, parts[1], st_var
    			(*s_ptr).run_name = STRTRIM(st_var,2)
    		end
    		if(parts[0] eq 'LASTDATE') then begin
    			reads, parts[1], st_var
    			(*s_ptr).last_date = STRTRIM(st_var,2)
			end
    		if(parts[0] eq 'REDUCER')  then begin
    			reads, parts[1], st_var
    			(*s_ptr).who = STRTRIM(st_var,2)
			end
    		if(parts[0] eq 'ROOT_RAW') then begin
    			reads, parts[1], st_var
    			(*s_ptr).root_raw = STRTRIM(st_var,2)
			end
    		if(parts[0] eq 'NUM_NHTS') then begin
    			reads, parts[1], lng_var
    			(*s_ptr).num_nights = lng_var
    		endif
    		if(parts[0] eq 'NIGHT')    then begin
    			reads, parts[1], inight
    			reads, parts[3], lng_var
    			(*s_ptr).night_date[inight-1] = lng_var
    			reads, parts[5], lng_var
    			(*s_ptr).night_images[inight-1] = lng_var
    			reads, parts[7], i_var
    			(*s_ptr).night_step[inight-1] = i_var
    			reads, parts[9], st_var
    			(*s_ptr).night_comment[inight-1] = STRTRIM(st_var, 2)
    			if(count gt 10) then begin
    				reads, parts[11], st_var
    				(*s_ptr).night_who[inight-1] = STRTRIM(st_var, 2)
    			endif else begin
    				(*s_ptr).night_who[inight-1] = 'none'
    			endelse
    			jnight++
    		endif
    	endif
    endwhile
    ;
    FREE_LUN, lu_summary
    ;
    (*s_ptr).who = return_value
    ;
    ;	check that nights match
    ;
    if(jnight ne (*s_ptr).num_nights) then begin
    	MSP_BDP_print_text, Event, "ERROR - number of nights and night list do not match!!"
    endif
	;
    ;	make P1 buttons sensitive
    ;
    sense = 1
    for i_P1 = 2, 6 do begin
		P1_button_sensitize, Event, i_P1, sense
	endfor
	;
	MSP_BDP_print_text, Event, "Opened Existing Summary File "+summary_path
	;
	;	and write the backup file
	;
	P1_Write_Summary_File, Event, /BACKUP
	;
	;
    ;	reset TLB title
    ;
    TLB_Title = (*s_ptr).version_string + $
    			' '+(*s_ptr).who+' '+SYSTIME()+' for Run '+(*s_ptr).run_name
    tlb_wid = WIDGET_INFO( Event.top, FIND_BY_UNAME='MSP_BDP_Base')
    ;
    WIDGET_CONTROL, tlb_wid, TLB_SET_TITLE=TLB_Title
	;
	P1_OER_end:
end
;
;-----------------------------------------------------------------
pro P1_Show_Night_Summary, Event
	;
	;	launch the Night Summary table gui
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	;
	s_ptr = PTR_struct.PTR_summary
	;
	max_step = (*s_ptr).max_step
	;
	;	first_struct contains known data and labels
	;
	col_headers = ["Night Desig.","No. Images","Step","Comments and Notations","Reducer"]
	;
	if( (*s_ptr).num_nights eq 0) then begin
		;
		;	no nights in summary, populate headers, add a dummy row of
		;	data
		;
		color_array = ["red", "red", "red", "red", "red"]
		row_headers = ["N_00"]
		data_array = {night_date: 999900L, night_images: -1L, night_step: -1L, night_summary: 'No Nights',$
						night_who: 'none'}
	endif else begin
		;
		;	non-zero number of nights in summary, populate headers, add a data rows
		;
		n_nights = (*s_ptr).num_nights
		;
		color_array = strarr(5,n_nights)
		;
		row_headers = strarr(n_nights)
		data_line = {night_date: 999911L, night_images: 0L, night_step: 0L, night_comment: '',$
						night_who: ''}
		data_array = REPLICATE(data_line, n_nights)							; array of structures
		;
		for inight = 0, n_nights-1 do begin
			row_headers[inight] = STRING(format='("N_",i2.2)',inight+1)
			data_array[inight].night_date    = (*s_ptr).night_date[inight]
			data_array[inight].night_images  = (*s_ptr).night_images[inight]
			data_array[inight].night_step    = (*s_ptr).night_step[inight]
			data_array[inight].night_comment = (*s_ptr).night_comment[inight]
			data_array[inight].night_who = (*s_ptr).night_who[inight]
			;
			color_array[0,inight] = "green"
			;
			if(data_array[inight].night_images eq 0) then color_array[1,inight] = "red" else $
					color_array[1,inight] = "green"
			;
			case data_array[inight].night_step of
				0:	color_array[2,inight] = "red"
				12: color_array[2,inight] = "green"
				else: color_array[2,inight] = "yellow"
			endcase
			;
			s_color = ''
			case data_array[inight].night_comment of
				"Done": 			s_color = "green"
				"disc. in raw": 	s_color = "orange"
				"newly added": 		s_color = "yellow"
				"Groups Built": 	s_color = "green"
				"Directory Built": 	s_color = "yellow"
				"No Shifts": 		s_color = "green"
				"Shifts Ignored": 	s_color = "green"
				"Shifts Fixed": 	s_color = "green"
				"No RAW1 Jumps":	s_color = "green"
				"RAW1 Jumps Fixed": s_color = "green"
				;
				"Images Coadded":	s_color = 'yellow'
				"Lin. Tables Made":	s_color = 'green'
				else: 	$
					begin
						;
						;	test for BPMs, ave RAW1
						;
						s_color = 'violet'
						if(STRPOS(data_array[inight].night_comment,"BPMs") ge 0) then s_color = 'green'
						if(STRPOS(data_array[inight].night_comment,"Ave RAW1") ge 0) then s_color = 'green'
						if(STRPOS(data_array[inight].night_comment,'Lin. Corr. Done') ge 0) then s_color = 'green'
						if(STRPOS(data_array[inight].night_comment,'Dark Images') ge 0) then s_color = 'green'
						if(STRPOS(data_array[inight].night_comment,'Groups Finished') ge 0) then s_color = 'green'
					end
			endcase
			color_array[3:4,inight] = s_color
		endfor
	endelse
	;
	r_string = STRING(format='("Summary for Run ",A6)', (*s_ptr).run_name)
	new_struct = Dialog_Table(Title="Night Summary Table",Label=r_string, $
					Group_Leader=Event.top, Col_Headers = col_headers, Row_headers = row_headers,$
					Data_array = data_array, Font='Helvetica*18', color_array=color_array)
	;
	;	load new table data back into structure
	;
	nc = N_TAGS(new_struct)
	nr = N_ELEMENTS(new_struct)
	;
	;	if only one row, and the night number is 999900L, then just return w/o changes
	;
	if(nr eq 1 and new_struct[0].night_date eq 999900L) then goto, P1_SNS_end
	;
	;	otherwise, save by row
	;
	for ir = 0, nr-1 do begin
		(*s_ptr).night_date[ir] = new_struct[ir].night_date
		(*s_ptr).night_images[ir] = new_struct[ir].night_images
		(*s_ptr).night_step[ir] = new_struct[ir].night_step
		(*s_ptr).night_comment[ir] = STRTRIM(new_struct[ir].night_comment,2)
		(*s_ptr).night_who[ir] = STRTRIM(new_struct[ir].night_who,2)
	endfor
	;
	P1_SNS_end:
end
;
;-----------------------------------------------------------------
pro P1_Discover_Raw_Nights, Event
	;
	;	goes to the raw directory, then builds the list of nights from what is found there
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	;
	s_ptr = PTR_struct.PTR_summary		; shortened pointer name
	;
	root_raw = (*s_ptr).root_raw
	;
	;	get a list of all the directories there
	;
	;print, "root_raw = ",root_raw
	;print, "root_reduced = ",(*s_ptr).root_reduced
	;
	root_raw_subs = root_raw + "*"
	;
	;print, "root_raw_subs = ",root_raw_subs
	;
	raw_night_list = FILE_SEARCH(root_raw_subs, /TEST_DIRECTORY, /FOLD_CASE, $
						/MARK_DIRECTORY, COUNT=count)
	;
	;print, "raw_night_list = ",raw_night_list
	;	test for none
	;
	if(count eq 0) then begin
		MSP_BDP_print_text, Event, "No Nightly Raw Directories Found, Returning"
		goto, P1_DR_end
	endif else begin
		;
		;	get the list of nights
		;
		night_list = FILE_BASENAME(raw_night_list)
		;
		;	cull any that don't start with "20" (ie logs and such)
		;
		match_20 = STRPOS(night_list[*], '20')
		ind_20 = WHERE(match_20 ne -1)
		night_list = night_list[ind_20]
		;
		count = N_ELEMENTS(night_list)
		;print, "night_list: ",night_list
		;
		; update the data base
		;
		(*s_ptr).num_nights = count
		;
		;	sort the list
		;
		ind_n = SORT(night_list)
		;
		lng_night = 0L
		for i_night = 0, count-1 do begin
			reads, night_list[ind_n[i_night]], format='(I8)', lng_night
			(*s_ptr).night_date[i_night] = lng_night
			(*s_ptr).night_images[i_night] = 0L
			(*s_ptr).night_step[i_night] = 0L
			(*s_ptr).night_comment[i_night] = "disc. in raw"
			(*s_ptr).night_who[i_night] = (*s_ptr).who
		endfor
		;
	endelse
    ;
	MSP_BDP_print_text, Event, "Discovered "+STRING(format='(i2.2)',count)+" Raw Nights"
	;
	P1_DR_end:
end
;
;-----------------------------------------------------------------
pro P1_Add_Nights, Event
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	;
	s_ptr = PTR_struct.PTR_summary		; shortened pointer name
	;
	;	ask for night to add
	;
	new_night = Dialog_Text(Title="Add Night To Summary", Label="Enter Night Designator (YYYYMMDD)", $
    						Font='Helvetica*18', Group_Leader = Event.top)				;
    WIDGET_CONTROL, DEFAULT_FONT = (*s_ptr).default_font
    if(SIZE(new_night,/TYPE) ne 7) then begin
	    if( new_night eq -1) then begin
	    	MSP_BDP_print_text, Event, "ERROR - No text entered. Try Again."
	    	goto, P1_A_end
	    endif
	endif
    ;
    ;	convert to number, then insert in list in correct place
    ;
    lng_night = 0L
    reads, new_night, lng_night
    ;
    num_nights = (*s_ptr).num_nights
	;
	;	first check that the night isn't already in the list
	;
	ind_m = WHERE(lng_night eq (*s_ptr).night_date[*],count)
	if(count ne 0) then begin
		MSP_BDP_print_text, Event, "ERROR - Night "+new_night+" Aready on list, Ignoring"
		goto, P1_A_end
	endif
	;
	(*s_ptr).night_date[num_nights] = lng_night
	(*s_ptr).night_images[num_nights] = 0L
	(*s_ptr).night_step[num_nights] = 0L
	(*s_ptr).night_comment[num_nights] = "newly added"
	(*s_ptr).night_who[num_nights] = (*s_ptr).who
	(*s_ptr).num_nights++
	;
	;	if more than one, sort
	;
	if(num_nights gt 0) then begin
		ind = SORT( (*s_ptr).night_date[0:num_nights] )
		;
		;	do the sort of the relevant terms
		;
		(*s_ptr).night_date[0:num_nights] = (*s_ptr).night_date[ind]
		(*s_ptr).night_images[0:num_nights] = (*s_ptr).night_images[ind]
		(*s_ptr).night_step[0:num_nights] = (*s_ptr).night_step[ind]
		(*s_ptr).night_comment[0:num_nights] = (*s_ptr).night_comment[ind]
		(*s_ptr).night_who[0:num_nights] = (*s_ptr).night_who[ind]
	endif
	;
	MSP_BDP_print_text, Event, "Added Night "+new_night+" to Summary"
	;
	P1_A_end:
end
;
;-----------------------------------------------------------------
pro P1_Delete_Nights, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	;
	s_ptr = PTR_struct.PTR_summary		; shortened pointer name
	;
	;	ask for night to delete
	;
	new_night = Dialog_Text(Title="Delete Night From Summary", $
							Label="Enter Night Designator (YYYYMMDD)", $
    						Font='Helvetica*18', Group_Leader = Event.top)				;
    WIDGET_CONTROL, DEFAULT_FONT = (*s_ptr).default_font
    if(SIZE(new_night,/TYPE) ne 7) then begin
	    if( new_night eq -1) then begin
	    	MSP_BDP_print_text, Event, "ERROR - No text entered. Try Again."
	    	goto, P1_D_end
	    endif
	endif
    ;
    ;	convert to number, then match in list and remove
    ;
    lng_night = 0L
    reads, new_night, lng_night
    ;
    num_nights = (*s_ptr).num_nights
    ;
    ;	match to list
    ;
    ind_m = WHERE(lng_night eq (*s_ptr).night_date[*],count)
    ;
    if(count eq 0) then begin
    	;
    	MSP_BDP_print_text, Event, "ERROR - "+new_night+" is not in Summary, Returning"
    	;
    	goto, P1_D_end
    endif
    ;
    ;	match occurred. Check for multiple matches
    ;
    if(count ne 1) then begin
    	;
    	MSP_BDP_print_text, Event, "ERROR - "+new_night+" has multiple matches in Summary, Returning"
    	;
    	goto, P1_D_end
    endif
	;
	;	delete by changing date to high value, sorting, then rewriting
	;
	;		but, if only one item listed, just clear it and return
	;
	if(num_nights eq 1) then begin
		(*s_ptr).num_nights = 0L
		(*s_ptr).night_date[0] = 0L
		(*s_ptr).night_images[0] = 0L
		(*s_ptr).night_step[0] = 0
		(*s_ptr).night_comment[0] = ''
		(*s_ptr).night_who[0] = (*s_ptr).who
	endif else begin
		;
		(*s_ptr).night_date[ind_m] = 99999999
		;
		ind = SORT( (*s_ptr).night_date[0:num_nights-1] )
		;
		;	do the sort of the relevant terms
		;
		(*s_ptr).night_date[0:num_nights-1] = (*s_ptr).night_date[ind]
		(*s_ptr).night_images[0:num_nights-1] = (*s_ptr).night_images[ind]
		(*s_ptr).night_step[0:num_nights-1] = (*s_ptr).night_step[ind]
		(*s_ptr).night_comment[0:num_nights-1] = (*s_ptr).night_comment[ind]
		(*s_ptr).night_who[0:num_nights-1] = (*s_ptr).night_who[ind]
		;
		;	then, clear the last one and reset the night number
		;
		(*s_ptr).night_date[num_nights-1] = 0L
		(*s_ptr).night_images[num_nights-1] = 0L
		(*s_ptr).night_step[num_nights-1] = 0L
		(*s_ptr).night_comment[num_nights-1] = ''
		(*s_ptr).night_who[num_nights-1] = (*s_ptr).who
		(*s_ptr).num_nights--
	endelse
	;
	MSP_BDP_print_text, Event, "Deleted Night "+new_night+" from Summary"
	;
	P1_D_end:
end
;
;-----------------------------------------------------------------
pro P1_Print_Run_Summary_File, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	;
	;	open print file
	;
	s_print_file = fix_path(FILEPATH("Summary_Print.txt",ROOT_DIR=(*s_ptr).root_reduced,$
				SUBDIRECTORY='0_Analysis_Summary'))
	openw, lu_print, s_print_file, /GET_LUN
	;
	;	write to it
	;
	printf, lu_print, "MSP_BDP - Observing Run Summary"
	printf, lu_print, "-----------------------------------------------------------"
	printf, lu_print, "Created: ",SYSTIME()
	printf, lu_print, "  "
	printf, lu_print, "Run Name Designation: ",(*s_ptr).run_name
	printf, lu_print, "Person Last Working on this analysis: ",(*s_ptr).who
	printf, lu_print, "Raw Data Root Directory: ",(*s_ptr).root_raw
	printf, lu_print, "Reduced Data Root Directory: ",(*s_ptr).root_reduced
	printf, lu_print, "Number of Nights in Observing Run: ",(*s_ptr).num_nights
	printf, lu_print, "  "
	printf, lu_print, "Night Summary:"
	printf, lu_print, "-----------------------------------------------------------"
	printf, lu_print, "Night          Images      Step       Comment           Reducer"
	printf, lu_print, "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -"
	;
	for inight = 0, (*s_ptr).num_nights-1 do begin
		printf, lu_print, STRTRIM((*s_ptr).night_date[inight],2),$
						  (*s_ptr).night_images[inight],"  ",$
						  (*s_ptr).night_step[inight],"       ",$
						  (*s_ptr).night_comment[inight], $
						  (*s_ptr).night_who[inight]
	endfor
	;
	;	close file
	;
	FREE_LUN, lu_print
	;
	MSP_BDP_print_text, Event, "Wrote Summary File to: "+s_print_file
	MSP_BDP_print_text, Event, "  Use Native Operating System to view or print"
	;
end
;
;------------------------------------------------------------------------------------
;
pro P1_Reconnect_Directories, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	;
	;	rewrites the summary file directories, based on user selections
	;
	;	(like open-new, but already opened)
	;
	MSP_BDP_print_text, Event, "Reconnection to existing data directories requested"
    ;
    ;
	;	select root reduced data directory
    ;
    P1_RD1:
    summary_dir = Dialog_Pickfile(Title="New Reduced Data Directory",/directory)
    if(summary_dir eq '') then begin
    	MSP_BDP_print_text, Event, "No directory specified. Try again."
    	goto, P1_RD1
    endif
    ;
    ;	in that directory, look for the analysis summary sub directory
    ;
    root_dir = summary_dir
	summary_dir = fix_path(summary_dir + PATH_SEP() + '0_Analysis_Summary')
	test_dir = FILE_INFO(summary_dir)
	if(test_dir.exists ne 1 or test_dir.directory ne 1) then begin
		MSP_BDP_print_text, Event, 'ERROR - Anayisis directory absent - Try again.'
		goto, P1_RD_end
	endif else begin
		MSP_BDP_print_text, Event, "Found existing Analysis Summary file OK"
	endelse
	;
	(*s_ptr).root_reduced = fix_path(root_dir)
	;
	;	now, connect to raw data, if desired
	;
	P1_RD2:
	raw_dir = Dialog_Pickfile(Title="New Raw Data Directory",/directory)
	if(raw_dir eq '') then begin
		MSP_BDP_print_text, Event, "No directory specified. Try again."
    	goto, P1_RD2
    endif
	;
	(*s_ptr).root_raw = raw_dir
    ;
    P1_RD3:
    (*s_ptr).last_date = systime()
    return_value = Dialog_Text(Title="Data Reduction Operator", Label="Enter Your Name", $
    						Font='Helvetica*24', Group_Leader = Event.top)
    ;
    if(SIZE(return_value,/TYPE) ne 7) then begin		; check for -1 error code
	    if(return_value eq -1) then begin
	    	MSP_BDP_print_text, Event, "ERROR - No Text Entered. Try Again."
	    	goto, P1_RD3
	    endif
	endif
	;
	(*s_ptr).who = STRTRIM(return_value,2)
    ;
    WIDGET_CONTROL, DEFAULT_FONT = (*s_ptr).default_font
    ;
    ;	find, open, and read from the summary file
    ;
    files = FILE_SEARCH(summary_dir,'*_summary.dat')
    nfiles = N_ELEMENTS(files)
    if(nfiles eq 1) then begin
    	len = STRLEN(files[0])
    	if(len eq 0) then begin
    		MSP_BDP_print_text, Event, "ERROR - run summary file not found. Try again."
    		goto, P1_RD_end
    	endif
    	;
    	;	the one file found is the right one
    	;
    	summary_path = files[0]
    endif else begin
    	;
    	;	multiple files, write error
    	;
    	MSP_BDP_print_text, Event, "ERROR - found "+STRING(nfiles)+" summary files. Fix this."
    	goto, P1_RD_end
    endelse
    ;
    ;	set date time
    ;
    (*s_ptr).last_date = systime()
    ;
    openr, lu_summary, summary_path, /GET_LUN
    ;
    line = ''
    st_var = ''
    lng_var = 0L
    i_var = 0
    jnight = 0
    WHILE (~EOF(lu_summary)) do begin
    	readf, lu_summary, line
    	parts = STRSPLIT(line,"::",/REGEX,/EXTRACT, Count=count)		; break into parts
    	if(count ne 0) then begin
    		;
    		;	found "::" separator, examine pieces
    		;
    		parts[0] = STRTRIM(parts[0],2)
    		if(parts[0] eq 'RUN_NAME') then begin
    			reads, parts[1], st_var
    			(*s_ptr).run_name = STRTRIM(st_var,2)
    		end
;    		if(parts[0] eq 'LASTDATE') then begin
;    			reads, parts[1], st_var
;    			(*s_ptr).last_date = STRTRIM(st_var,2)
;			end
;    		if(parts[0] eq 'REDUCER')  then begin
;    			reads, parts[1], st_var
;    			(*s_ptr).who = STRTRIM(st_var,2)
;			end
;    		if(parts[0] eq 'ROOT_RAW') then begin
;    			reads, parts[1], st_var
;    			(*s_ptr).root_raw = STRTRIM(st_var,2)
;			end
    		if(parts[0] eq 'NUM_NHTS') then begin
    			reads, parts[1], lng_var
    			(*s_ptr).num_nights = lng_var
    		endif
    		if(parts[0] eq 'NIGHT')    then begin
    			reads, parts[1], inight
    			reads, parts[3], lng_var
    			(*s_ptr).night_date[inight-1] = lng_var
    			reads, parts[5], lng_var
    			(*s_ptr).night_images[inight-1] = lng_var
    			reads, parts[7], i_var
    			(*s_ptr).night_step[inight-1] = i_var
    			reads, parts[9], st_var
    			(*s_ptr).night_comment[inight-1] = STRTRIM(st_var, 2)
    			if(count gt 10) then begin
    				reads, parts[11], st_var
    				(*s_ptr).night_who[inight-1] = STRTRIM(st_var, 2)
    			endif else begin
    				(*s_ptr).night_who[inight-1] = 'none'
    			endelse
    			jnight++
    		endif
    	endif
    endwhile
    ;
    FREE_LUN, lu_summary
    ;
    ;	check that nights match
    ;
    if(jnight ne (*s_ptr).num_nights) then begin
    	MSP_BDP_print_text, Event, "ERROR - number of nights and night list do not match!!"
    endif
	;
    ;	make P1 buttons sensitive
    ;
    sense = 1
    for i_P1 = 2, 7 do begin
		P1_button_sensitize, Event, i_P1, sense
	endfor
	;
	MSP_BDP_print_text, Event, "Reconnected Existing Directories "+summary_path
	;
	;	and write the backup file
	;
	P1_Write_Summary_File, Event, /BACKUP
	;
    ;	reset TLB title
    ;
    TLB_Title = (*s_ptr).version_string + $
    			' '+(*s_ptr).who+' '+SYSTIME()+' for Run '+(*s_ptr).run_name
    tlb_wid = WIDGET_INFO( Event.top, FIND_BY_UNAME='MSP_BDP_Base')
    ;
    WIDGET_CONTROL, tlb_wid, TLB_SET_TITLE=TLB_Title
    ;
    P1_RD_end:
	;
end