pro MSP_BDP_Query_Group_Info, Event, group_number, $
		filter, obs_type, camera, HWP_angle, ut, exptime, $
		date_obs, jd
	;
	;	for the group number, go to the
	;	first image on the group list and fetch its critical data:
	;		filter
	;		obs_type
	;		camera
	;		HWP_angle
	;		ut
	;		exptime
	;		date_obs
	;		julian date
	;
	;MSP_BDP_print_text, Event, "Group Info Query Requested"
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	n_ptr = PTR_struct.PTR_night
	s_ptr = PTR_struct.PTR_summary
	f_ptr = PTR_struct.PTR_FITS
	;
	;	get all info from the existing night summary files, already
	;	assumed loaded into memory
	;
	filter = (*n_ptr).groups[group_number].group_filter
	obs_type = (*n_ptr).groups[group_number].group_type
	camera = (*n_ptr).groups[group_number].group_camera
	exptime = (*n_ptr).groups[group_number].group_exptime
	;
	;	to get the rest of the information, must go to the
	;	stored FITS headers
	;
	image_0 = (*n_ptr).groups[group_number].group_list[0]
	;
	n_images = (*n_ptr).num_images
	ind = WHERE( (*n_ptr).image_list[0:n_images-1] eq image_0,count)
	if(count eq 1) then begin
		;
		date_obs = (*n_ptr).header_list[ind].date_obs
		ut = (*n_ptr).header_list[ind].ut
		;
		(*f_ptr).comment[0] = (*n_ptr).header_list[ind].comment[0]
		MSP_BDP_Parse_HWP_Angle, Event, HWP_angle
		;
		image_ut= ut
		year = 0L
		month = 0L
		day = 0L
		reads, date_obs, format='(I4,1x,i2,1x,i2)',year, month, day
		;
		hour = FLOOR(image_UT)
		minute = FLOOR((image_UT - double(hour))*60.0d0)
		second = 3600.0d0 * (image_UT - double(hour) - double(minute)/60.0d0)
		;
		jd = 0.0d0
		jd = JULDAY(month, day, year, hour, minute, ROUND(second))
	endif else begin
		date_obs = 'error'
		ut = 0.0
		HWP_angle = -99.9
		jd = -99.
	endelse
	;
;	print, "Exiting Query Group Info"
;	print, "  image_0, filter, obs_type = ",image_0, filter, obs_type
;	print, "    camera, HWP_angle, ut = ", camera, HWP_angle, ut
;	print, "    date_obs, jd, exptime = ",date_obs, jd, exptime
end

