pro P11_init, Event
	;
	;	gets the list of active nights with Step>=8 (LC must be ready
	;	first) onto the P11 list and does all
	;		other initializations
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	rt_ptr = PTR_struct.PTR_RTime
	;
	num_nights = (*s_ptr).num_nights
	;
	if(num_nights eq 0) then begin
		str_list = ['no nights on list']
	endif else begin
		night_list = (*s_ptr).night_date[0:num_nights-1]
		step_list = (*s_ptr).night_step[0:num_nights-1]
		ind = WHERE(step_list[*] ge 8, count)
		if(count lt 1) then begin
			str_list = ['no nights w/S>=8']
			MSP_BDP_print_text, Event, "No Nights Available for Flat Field Image Creation"$
								+" - Complete Linearity Correction first."
		endif else begin
			;
			;	put into structure array
			;
			(*rt_ptr).n_nights = count
			for i=0, count-1 do begin
				(*rt_ptr).night_list[i] = night_list[ind[i]]
				;
				;print,"night ",i," desig = ",(*d_ptr).night_list[i]
				;
			endfor
		endelse
	endelse
	;
	;	clear LED and buttons
	;
	for ib = 0, 2 do P11_LED_sensitize, Event, ib, 0
	P11_button_sensitize, Event, 0, 1
	for ib = 1, (N_ELEMENTS((*s_ptr).P11_button_wid) -1)  do P11_button_sensitize, Event, ib, 0
	;
	;	check directory - if exists and is not empty, then turn on button 3 to allow reentrant processing
	;
	rdt_dir = (*s_ptr).root_reduced + '11_Readout_Time' + PATH_SEP()
	test = FILE_INFO(rdt_dir)
	if(test.exists and test.directory) then begin
		file_list = FILE_SEARCH(rdt_dir+'*.fits',COUNT=count)
		if(count ne 0) then P11_button_sensitize, Event, 3, 1
	endif
	;
	;	get current value for read time from the textbox value
	;
	WIDGET_CONTROL, (*s_ptr).P11_text_wid[0], GET_VALUE=read_time
	rtv = 0.0d0
	reads, read_time, format='(f8.6)', rtv
	(*rt_ptr).read_time_value = rtv
	;
	;print, "Read time in text box = ",read_time
end