pro P12_Load_BPM_List, Event
	;
	;	read the BPM directory to get the image list,
	;	then read each header to get the night and UT
	;	for each image into the BDF summary structure
	;
	MSP_BDP_print_text, Event, "Fetch BPM List Requested"
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	n_ptr = PTR_struct.PTR_night
	s_ptr = PTR_struct.PTR_summary
	f_ptr = PTR_struct.PTR_FITS
	b_ptr = PTR_struct.PTR_BPM
	bdf_ptr = PTR_struct.PTR_BDF
	;
	;	first, build the directory path to search
	;
	root_reduced = (*s_ptr).root_reduced
	BPM_directory = (*b_ptr).bpm_directory		; what if not yet loaded?
	if(BPM_directory eq '') then BPM_directory = '5_Bad_Pixel_Masks'
	;
	BPM_dir_path = root_reduced + BPM_directory + PATH_SEP()
	;
	;print, "BPM_path = ",BPM_dir_path
	;
	;	get list of images in that directory
	;
	test_dir = FILE_INFO(BPM_dir_path)
	if( NOT(test_dir.exists) or NOT(test_dir.directory) ) then begin
		MSP_BDP_print_text, Event, "ERROR - BPM directory path incorrect"
		(*bdf_ptr).n_bpm = 0L
		goto, MBPBH_end
	endif
	;
	BPM_list = FILE_SEARCH(BPM_dir_path+'*.fits')
	;
	;print, "BPM_list = ",BPM_list
	;
	n_bpm = N_ELEMENTS(BPM_list)
	;
	MSP_BDP_print_text, Event, "Found "+STRING(format='(I)',n_bpm)+" BPM images."
	;
	;	open each and build the date, UT, path list
	;
	(*bdf_ptr).n_bpm = n_bpm
	;
	for ibpm = 0, n_bpm-1 do begin
		bpm_path = BPM_list[ibpm]
		(*bdf_ptr).bpm_path[ibpm] = bpm_path
		;
		;	read the BPM image
		;
		header_BPM = headfits(bpm_path, /silent)
		;
		;	load buffers
		;
		n_header_lines = N_ELEMENTS(header_BPM)
		(*s_ptr).raw_header[0:n_header_lines-1] = header_BPM
		(*s_ptr).raw_header[n_header_lines:N_ELEMENTS((*s_ptr).raw_header)-1] = ''
		;
		;	extract key values
		;
		MSP_BDP_Parse_FITS_Header, Event
		;
		(*bdf_ptr).bpm_ut[ibpm] = (*f_ptr).ut
		;
		date_obs = (*f_ptr).date_obs
		year = 0L
		month = 0L
		day = 0L
		reads, date_obs, format='(I4,1x,i2,1x,i2)',year, month, day
		night_desig = year * 10000L + month * 100L + day
		;
		bpm_UT = (*bdf_ptr).bpm_UT[ibpm]
		hour = FLOOR(bpm_UT)
		minute = FLOOR((bpm_UT - double(hour))*60.0d0)
		second = 3600.0d0 * (bpm_UT - double(hour) - double(minute)/60.0d0)
		;
		bpm_jd = JULDAY(month, day, year, hour, minute, ROUND(second))
		;
		(*bdf_ptr).bpm_jd[ibpm] = bpm_jd
		;
		;print, "BPM No. ",ibpm," Night, UT, JD = ",night_desig, (*bdf_ptr).bpm_UT[ibpm], (*bdf_ptr).bpm_jd[ibpm], $
		;		" path = ",(*bdf_ptr).bpm_path[ibpm]
	endfor
	;
	MBPBH_end:
end