pro P12_Load_Dark_List, Event
	;
	;	read the Dark directory to get the image list,
	;	then read each header to get the exposure time and UT
	;	for each image into the BDF summary structure
	;
	MSP_BDP_print_text, Event, "Fetch Dark List Requested"
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	n_ptr = PTR_struct.PTR_night
	s_ptr = PTR_struct.PTR_summary
	f_ptr = PTR_struct.PTR_FITS
	b_ptr = PTR_struct.PTR_BPM
	bdf_ptr = PTR_struct.PTR_BDF
	;
	;	first, build the directory path to search
	;
	root_reduced = (*s_ptr).root_reduced
	dark_directory = '9_Dark_Images'
	;
	dark_dir_path = root_reduced + dark_directory + PATH_SEP()
	;
	;print, "dark_path = ",dark_dir_path
	;
	;	get list of images in that directory
	;
	test_dir = FILE_INFO(dark_dir_path)
	if( NOT(test_dir.exists) or NOT(test_dir.directory) ) then begin
		MSP_BDP_print_text, Event, "ERROR - Dark directory path incorrect"
		(*bdf_ptr).n_dark = 0L
		goto, MBPBH_end
	endif
	;
	dark_list = FILE_SEARCH(dark_dir_path+'*.fits')
	;
	;print, "dark_list = ",dark_list
	;
	n_dark = N_ELEMENTS(dark_list)
	;
	MSP_BDP_print_text, Event, "Found "+STRING(format='(I)',n_dark)+" Dark images."
	;
	;	open each and build the expt, date, UT, path list
	;
	(*bdf_ptr).n_dark = n_dark
	;
	for idark = 0, n_dark-1 do begin
		dark_path = dark_list[idark]
		(*bdf_ptr).dark_path[idark] = dark_path
		;
		;	read the dark image
		;
		header_dark = headfits(dark_path, /silent)
		;
		;	load buffers
		;
		n_header_lines = N_ELEMENTS(header_dark)
		(*s_ptr).raw_header[0:n_header_lines-1] = header_dark
		(*s_ptr).raw_header[n_header_lines:N_ELEMENTS((*s_ptr).raw_header)-1] = ''
		;
		;	extract key values
		;
		MSP_BDP_Parse_FITS_Header, Event
		;
		(*bdf_ptr).dark_ut[idark] = (*f_ptr).ut
		;
		(*bdf_ptr).dark_exptime[idark] = (*f_ptr).exptime
		;
		date_obs = (*f_ptr).date_obs
		year = 0L
		month = 0L
		day = 0L
		reads, date_obs, format='(I4,1x,i2,1x,i2)',year, month, day
		night_desig = year * 10000L + month * 100L + day
		;
		;	save JD value
		;
		dark_UT = (*bdf_ptr).dark_ut[idark]
		hour = FLOOR(dark_UT)
		minute = FLOOR((dark_UT - double(hour))*60.0d0)
		second = 3600.0d0 * (dark_UT - double(hour) - double(minute)/60.0d0)
		;
		dark_jd = JULDAY(month, day, year, hour, minute, ROUND(second))
		;
		(*bdf_ptr).dark_jd[idark] = dark_jd
		;
		;print, "Dark No. ",idark," ExpT = ",(*bdf_ptr).dark_exptime[idark], $
		;		" Night, UT, JD = ",night_desig, (*bdf_ptr).dark_UT[idark], dark_jd, " path = ",dark_path
	endfor
	;
	MBPBH_end:
end