pro dump_headers
;
;	reads FITS headers for selected CDS images and
;	writes a table of key data values, one line per image
;
;
;	DPC		20111124
;
files = dialog_pickfile(title='Select CDS Images',/multiple_files)
;
nf = N_ELEMENTS(files)
;
file_out = dialog_pickfile(title='Output Summary File')
openw, lu_out, file_out, /GET_LUN
;
fpos = intarr(4)
fcode = intarr(4)
fname = strarr(4)
;
printf, lu_out, '  File Name     Object    Tint     Comment      -POL(NM,P,C)-'+$
    '  -FW1(NM,P,C)-    -FW2(NM,P,C)-   -FW3(NM,P,C)-  '+$
    ' -HWP(P,Ang,home)-'
;
fmt = '(a12,1x,A10,1x,f7.3,1x,a12,1x,4(a8,1x,i2,1x,i2,2x),2x,i3,1x,f6.2,1x,a4)'
;
for ifile = 0, nf-1 do begin
	;
	image = readfits(files[ifile],header)
	;
	;	for each filter wheel, grab key values
	;
	for jf = 1, 4 do begin
		FILT_N = 'FILT_'+STRING(jf,format='(i1)')
		FN_ECODE = 'F'+STRING(jf,format='(i1)')+'_ECODE'
		FILTNMEN = 'FILTNME'+STRING(jf,format='(i1)')
		;
		fpos[jf-1] = SXPAR(header, FILT_N)
		fcode[jf-1] = SXPAR(header, FN_ECODE)
		fname[jf-1] = STRTRIM(SXPAR(header, FILTNMEN),2)
	endfor
	;
	object = SXPAR(header, 'OBJECT')
	hwp = SXPAR(header, 'HWP')
	hwp_ang = SXPAR(header, 'HWP_ANG')
	hwp_home = SXPAR(header, 'H_HOME')
	if(hwp_home) then hwp_home ='Home' else hwp_home = 'Off'
	exptime = SXPAR(header, 'EXPTIME')
	comment = STRTRIM(SXPAR(header, 'COMMENT'),2)
	n_comment = N_ELEMENTS(comment)
	if(n_comment gt 1) then begin
		the_comment = comment[0] + comment[1]
	endif else begin
		the_comment = comment[0]
	endelse
	;
	printf, lu_out, format=fmt, FILE_BASENAME(files[ifile],'.fits'),object,exptime,the_comment,$
		fname[0],fpos[0],fcode[0],fname[1],fpos[1],fcode[1],fname[2],fpos[2],fcode[2],$
		fname[3],fpos[3],fcode[3],hwp,hwp_ang,hwp_home
endfor
;
FREE_LUN, lu_out
;
print, 'Done!'
end