pro hedit
;
;   program to edit a bunch of FITS headers
;
;   used to fix problems with COMMENTS (esp for polarimetry)
;
;   DPC 20051012    original code
;       20060725    modified to allow adding COMMENT lines w/o replacement
;
files_in = dialog_pickfile(Title="Select FITS files to edit",/MULTIPLE_FILES)
nfiles = size(files_in)
nfiles = nfiles[1]
;
print, "Name of FITS Header Variable?"
h_name = ''
read, format='(a8)',h_name
;
;   read first file and report current value
;
header = headfits(files_in[0])
value = FXPAR(header,h_name,COUNT=count)
if(count lt 2) then begin
    print, "Current value of ",h_name," is :"
    print, value
    ;
    print, "Would you like to change it? (Y/N)"
    iyn = ''
    read, iyn
    if(STRUPCASE(iyn) eq 'Y') then begin
       print, "New value to set it to?"
       new_value = value
       read, new_value
       ichange = 1
    endif else ichange = 0
endif else begin
    ichange = intarr(count)
    for icount = 0, count-1 do begin
       print, "Current value of ",h_name,"[",icount,"] is :"
       print,value[icount]
       print, "Would you like to change it? (Y/N)"
       iyn = ''
       read, iyn
       if(STRUPCASE(iyn) eq 'Y') then begin
         print, "New value to set it to?"
         new_value = value
         nv = ''
         read, nv
         new_value[icount] = nv
         ichange[icount] = 1
       endif else ichange[icount] = 0
    endfor
    ;
    ;   if no changes, do you want to add a comment?
    ;
    if (TOTAL(ichange) eq 0) then begin
        print, "Do you wish to add an additional COMMENT? (Y/N)"
        iyn = ''
        read, iyn
        if(STRUPCASE(iyn) eq 'Y') then begin
           print,"What comment should be added?"
           add_value = ''
           read, add_value
           ichange = [ichange,1]
           count++
           new_value = [value, "  " + add_value]
        endif
    endif
endelse
;
;   if change selected, do it
;
nch = N_ELEMENTS(ichange)
if(nch eq 0) then goto, finish
if(nch eq 1) then begin
    if(ichange eq 1) then begin
        for ifile = 0, nfiles-1 do begin
            image = readfits(files_in[ifile],header)
            FXADDPAR, header, h_name, new_value, "Edited by HEDIT.PRO"
            writefits, files_in[ifile], image, header
        endfor
    endif
endif else begin
    for icount = 0, count-1 do begin
       if(ichange[icount] eq 1) then begin
         for ifile = 0, nfiles-1 do begin
          image = readfits(files_in[ifile],header)
          FXADDPAR, header, h_name, new_value[icount], "Edited by HEDIT.PRO"
          writefits, files_in[ifile], image, header
         endfor
       endif
    endfor
endelse
;
finish:
;
print, "Hedit Done!"
end

