function make_kokepeli_kernel,empty
;
;   makes a kernel for convolving
;
;   DPC     20050726 original code from make_kernel.pro
;           20050727 modified into function form
;
;-----------------------------------------------------
;
;   a "right-hand Kokepeli" finder
;
a = -10.
b = +1.
c = +0.5
d = +0.1
;
k = [[c,b,a,a,b,c,c,c,c,d,d,d,d],$
     [c,c,b,a,a,b,c,c,c,c,d,d,d],$
     [c,c,c,b,a,b,c,c,c,c,d,d,d],$
     [c,c,c,b,a,a,b,c,c,c,c,d,d],$
     [c,c,c,c,b,a,b,c,c,c,c,d,d],$
     [c,c,c,c,b,a,a,b,c,c,c,c,d],$
     [d,c,c,c,c,b,a,b,c,c,c,c,d],$
     [d,c,c,c,c,b,a,a,b,c,c,c,c],$
     [d,d,c,c,c,c,b,a,b,c,c,c,c],$
     [d,d,c,c,c,c,b,a,a,b,c,c,c],$
     [d,d,d,c,c,c,c,b,a,b,c,c,c],$
     [d,d,d,c,c,c,c,b,a,a,b,c,c],$
     [d,d,d,d,c,c,c,c,b,a,a,b,c]]
;
;   scale along Y also
;
k[*,0] = k[*,0]*0.1
k[*,1] = k[*,1]*0.2
k[*,2] = k[*,2]*0.4
k[*,3] = k[*,3]*0.8
k[*,4] = k[*,4]*1.6
k[*,5] = k[*,5]*3.2
k[*,6] = k[*,6]*10.0
k[*,7] = k[*,7]*3.2
k[*,8] = k[*,8]*1.6
k[*,9] = k[*,9]*0.8
k[*,10] = k[*,10]*0.4
k[*,11] = k[*,11]*0.2
k[*,12] = k[*,12]*0.1
;
;
return, k
end
