function offset_fit, x,y,MEASURE_ERRORS=sy,SIGMA=sfit,YFIT=yfit
;
;   analogous to LINFIT, but only fits constant term
;
;   DPC   20060304  fixed problem with infinite weight
;
slope = 1.759259d0
sy_size = SIZE(sy)
npts = sy_size[1]
;
;   start by finding mean uncertainty
;
m_unc = median_filtered_mean(sy)
;
weight = fltarr(npts)
weight[*] = 0.0
denom = (((m_unc[0] - m_unc[1]*3.) > sy)^2)
ind = WHERE(denom ne 0.0,count)
if(count gt 0) then weight[ind] = 1./denom[ind]
;
sum = 0.0d0
s_weight = 0.0d0
;
n = n_elements(x)
for i = 0, n-1 do begin
    sum = sum + (y[i] - slope * x[i]) * weight[i]
    s_weight = s_weight + weight[i]
endfor
;
offset = sum / s_weight
rms = sqrt(1./s_weight)
;
yfit = offset + slope * x
resid = y - yfit
;
zz = median_filtered_mean(resid)
;
sfit = zz[1]
;
result = fltarr(2)
result[0] = offset
result[1] = slope
;
sfit = fltarr(2)
sfit[0] = rms
sfit[1] = 0.00001
;
return, result
end
